<?php
function cSpriteAdminMenuChecksFailed(){
 add_options_page(__('cSprites Options'), __('cSprites'), 8, __FILE__, 'cSpriteOptionsPageChecksFailed');
}
function cSpriteAdminMenu() {
  add_options_page(__('cSprites Options'), __('cSprites'), 8, __FILE__, 'cSpriteOptionsPage');
}

function cSpriteClearCache(){
  remove_action('update_option_cSpriteClearCacheNow', 'cSpriteClearCache');
  if(isset($_REQUEST['cSpriteClearCacheNow'])){
    Sprite::clearCache();
  }
  update_option('cSpriteClearCacheNow', 0);
  return 0;
}

function cSpriteOptionsPage(){
?>
<div class="wrap">
<h2><?php _e('cSprites for Wordpress');?></h2>

<form method="post" action="options.php">
<?php wp_nonce_field('update-options'); ?>

<table class="form-table">

<tr valign="top">
<th scope="row"><label for="cSpriteJpgQuality"><?php _e('JPG Quality');?></label></th>
<td><input type="text" name="cSpriteJpgQuality" id="cSpriteJpgQuality" value="<?php echo get_option('cSpriteJpgQuality'); ?>" class="regular-text code"/><span class="setting-description"><?php _e('0 lowest - 100 highest (Default: 70)');?></span></td>
</tr>
 
<tr valign="top">
<th scope="row"><label for="cSpritePngCompression"><?php _e('PNG Compression');?></label></th>
<td><input type="text" id="cSpritePngCompression" name="cSpritePngCompression" value="<?php echo get_option('cSpritePngCompression'); ?>" class="regular-text code"/><span class="setting-description"><?php _e('1 lowest - 9 highest (Default: 9)');?></span></td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpriteCacheTime"><?php _e('Cache Time in Minutes');?></label></th>
<td><input type="text" name="cSpriteCacheTime" id="cSpriteCacheTime" value="<?php echo get_option('cSpriteCacheTime'); ?>" class="regular-text code"/><span class="setting-description"><?php _e('set to 0 for no cache (Default: 20)');?></span></td>
</tr>


<tr valign="top">
<th scope="row"><label for="cSpriteForceNoPadding"><?php _e('Force no padding in image style');?></label></th>
<td><select name="cSpriteForceNoPadding" id="cSpriteForceNoPadding"/>
      <option value="1"><?php _e('True');?></option>
      <option value="0" <?php echo (get_option('cSpriteForceNoPadding'))?(''):('selected'); ?> ><?php _e('False');?></option>
    </select>
    <span class="setting-description"><?php _e('setting this to true will add a <em>padding:0 !important;</em> style to each image class; this will prevent padding from exposing other parts of the sprite. (Default: true)');?></span>
    </td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpriteClearCacheNow"><?php _e('Clear cSprite Cache');?></label></th>
<td><input type="checkbox" name="cSpriteClearCacheNow" id="cSpriteClearCacheNow"/>
    <span class="setting-description"><?php _e('Immediately deletes all the files in the cSprite cache. May help with images not displaying properly.');?></span>
    </td>
</tr>

</table>

<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="cSpriteJpgQuality,cSpritePngCompression,cSpriteCacheTime,cSpriteForceNoPadding,cSpriteClearCacheNow" />

<p class="submit">
<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
</p>

</form>
</div>
<?php 
} //end function 

function cSpriteOptionsPageChecksFailed(){
?>
<div class="wrap">
<h2><?php _e('cSprites for Wordpress');?></h2>
<h3>The following problems occurred in your installation:</h3>
<?php if(!cSpriteCheckCacheWritable()):?>
  <div style="background-color: rgb(255, 251, 204);" id="message" class="error"><p>The directory: <strong><em><?php echo CSPRITE_CACHE_DIR; ?></em></strong> was not writable. Please modify permissions.</p></div>
<?php endif; ?>
<?php if(!cSpriteCheckPhpVersion()): ?>
  <div style="background-color: rgb(255, 251, 204);" id="message" class="error"><p>You are currently running PHP <strong><?php echo phpversion(); ?></strong>. cSprites only supports PHP versions &gt; <strong>5.0.0</strong></p></div>
<?php endif; ?>
<h4>In order to run cSprites please fix these problems and refresh this screen.</h4>
<?php
}
?>